# RBC Library

![Logo](logo.png)

-------------------------------------

## 声明

* 以下RBC系列Sketchup插件简称RBC插件。

* RBC插件需要注册的功能为限制使用范围的插件。
  除了定义为需要限制使用的插件，其他的插件即为免费插件。
  限制使用的功能只有很少的部分。这部分通常不收费，只是限制使用人群。

* RBC插件允许所有用户、网站以及公司或者组织转载、使用RBC免费插件。

* RBC插件非常欢迎提供反馈意见，有建议都可以给我留言，邮箱(932180146@qq.com)。
  但是RBC对用户使用RBC免费插件过程中造成对损失不承担任何责任。

* RBC插件支持多版本、多语言。支持和提倡自主翻译语言。当然汉化也是一样的。

* 尽力和SketchUp原生态保持一致。

* 尽量让用户以最直接简洁的方式解决问题，而不是需要学习大量重复的插件。

* 容易学习使用。

* 使用成熟的技术维护和支持、整体的设计以及细节考虑，操作习惯尽量保持统一。

* 尽力提供SketchUp建模的最佳方案。

## 注意

* 尽量使用最新的正式版。

* 开发版一般会增加实验特性。并不能保证一定稳定。
  开发版一般用于测试。可能会出现问题。

* RBC扩展库为所有的RBC 插件提供扩展支持。所有的RBC插件都需要安装RBC扩展库！

* 7.0版本为了长远考虑，为用户体验感和开发维护的考虑，采用了全新的构架，摒弃了原来架构的一些弱点。
  同时也因此失去了与之前版本的兼容性。RBC系列插件会全面更新。
  只是架构上的改变，对功能不会改变，切换版本时请全面更新新版本。

* RBC扩展库有什么用？

* 已经安装了旧版本的RBC插件，想安装新版本，我需不需要先卸载旧版本？
  可以直接安装新版本，但是需要重新打开Sketchup才能生效！

## 适用范围

### 最低配置
* Sketchup 2015及其以上版本
* windows 7
* IE 9 以上
* osx safari ?

### 推荐使用
* windows 7-10
* Sketchup 2015-2018
* IE 10 以上

## 简要

* 简洁实用方便，即是不过度设计，以解决问题为第一要务。
  并且尽量隐藏不必要的概念。尽量帮助用户且尽量少地干扰用户。
  缄默原则，如果没什么好说的，就什么也不要说。
  还有一个功能尽量只做好一件事情。
  
* 高效，即是通过对瓶颈进行分析，通过各种手段进行追求性能。

* 兼容性，即是兼容指定的SketchUp版本范围以及同其他插件生态进行兼容。
  不与其他插件生态冲突。
  不能出现由自己造成的任何崩溃。这是绝对的底线。

* 易学易入手，最小知识原则。即是尽量考虑人的学习成本。
  同一个问题，提供一个建议选项。但同时支持多样的方式。
  繁多的插件。易于学习和公司采用以及培训。

* 集中功能模块。把功能相关的部分放到一起。
  但这不是插件集合包。

* 拥抱变化。不管承认不承认，事实是情况一直在变化，虽然有的快，有的慢。
  程序需要设计，但不过度设计。针对接口进行编程。
  合理的依赖关系。降低耦合。拥抱变化、敏捷开发。

* 完备的多国语言支持，用户可以自己翻译成自己国家或地区的语言。
  并支持导入导出。

* 尽量使用统一的UI以及同一的模式。

* 插件和建模相紧密结合。实践和理论相结合。

## 使用的开源项目
* Jquery
* Bootstrap
* rubyzip
* uuid
* LineTool
* Gizmo

-------------------------------------

## 更新概要

### 7.1.2
* 进一步完善
* 修复BUG

### 7.0.5
* 添加捐赠链接
* 优化API
* 修复bug

### 7.0.0
* 消除一些历史负担，优化设计结构。
* 修复bug.

### 6.5.0
* 优化建模体验
* 规范优化框架
* 修复BUG

### 6.3.0
* 属性
* 实例路径相关.
* 完善进度条.
* 修复bug.
* 完善Notification

### 6.2.0
* 添加基本的操作手柄模块.
* 修复错误.
* 删除声音模块.

### 6.0.8
* 添加欢迎界面。

### 6.0.0
* 适应官方的插件要求，重新架构RBC扩展库。

-------------------------------------

## 致谢

* SketchUp 团队
  Sketchup团队 设计了精巧的Sketchup系列产品。
  以人为主，简洁精悍。潜力强大。

* RBC Group
  RBC Group 是 RBC插件使用者自发组织的团队，维护RBC的正常运转。
  感谢 56度 的美工支持。
  感谢 少校 的教程支持。
  感谢 四毛 的维护支持。
  感谢 V 的完美测试。
  感谢每一个人。

* ThomThom
  ThomThom大牛写的很多东西给了RBC Group启发。
  很多严谨的作风和微妙的思路几乎是教科书式的典范。
  综合来看，是不可多的范本。

* Freedo6
  Freedo6设计的插件无一例外全是经典。几乎都是必装的插件。
  Sugar曾经做过粗略的数据统计，Freedo6系列插件安装率占第一。
  Freedo6系列插件，灵活强大。设计思路独树一帜，很多创新富有活力。
  在实用主义的思考上，给RBC Group了很多借鉴。

-------------------------------------

## 提供给各插件库

* 为方便识别，只要是RBC Group的插件，均以RBC开头。

* 首先加载RBC_Library
所有的RBC插件依赖RBC_Library运行,所以首先加载RBC_Library。

* 检查环境
RBC系列插件的运行需要一定的环境。
比如Sketchup 2015及其以上版本，以及IE版本不得低于9
可以通过 Sketchup.write_default("RBC_Library", "check_env", false) 可以选择强行禁止Lib自我检查。

* 第一次安装时会弹出帮助窗口
可以通过 Sketchup.write_default("RBC_Library", "show_startup", false) 可以选择强行禁止弹出窗口。

* 为保障体验，任何修改RBC的行为，都必须提前告知RBC Group。
